=== debian/changelog ===
openjk (0~20250523.2f6abb4+dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update
  * d/p/debian/build-Allow-a-packager-to-override-GIT_TAG.patch,
    d/rules:
    Use Debian packaging version instead of `git describe --tags`

 -- Simon McVittie <smcv@debian.org>  Sat, 24 May 2025 14:07:05 +0100
