=== debian/watch ===
version=4
opts="mode=git,dversionmangle=s/[~+](dfsg|ds)[0-9]*$//,compression=xz,repacksuffix=+dfsg,pretty=0~%cd.%h" \
https://github.com/JACoders/OpenJK \
HEAD
