=== debian/changelog ===
openjk (0~20251009.d1cb662+dfsg-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Remove Rules-Requires-Root, unnecessary since Debian 13
  * Normalize packaging (debputy reformat)
  * d/copyright: Remove outdated FSF postal address
  * d/salsa-ci.yml: Disable unnecessary build jobs
  * d/watch: Convert to uscan format v5

 -- Simon McVittie <smcv@debian.org>  Wed, 29 Oct 2025 10:29:06 +0000
